#if 0
gcc -s -O2 -o ./testpost testpost.c
exit
#endif

// Test posting; used to check that dot stuffing is working properly

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char buf[2000];

static void do_post(void) {
  int i;
  int s=1;
  for(;;) {
    i=fgetc(stdin);
    if(i==EOF) return;
    if(i=="\n.\r\n"[s]) s++; else s=0;
    fputc(i,stderr);
    if(s==4) break;
  }
}

int main(int argc,char**argv) {
  int i,nargs;
  setbuf(stdin,0);
  setbuf(stdout,0);
  setbuf(stderr,0);
  printf("200 Ready\r\n");
  while(fgets(buf,1500,stdin)) {
    i=strlen(buf);
    if(i && buf[i-1]=='\n') {
      buf[--i]=0;
    } else {
      while((i=getchar())!=EOF) if(i=='\n') break;
      if(i==EOF) return 0;
      printf("501 Command too long\r\n");
    }
    if(i && buf[i-1]=='\r') buf[--i]=0;
    while(i && (buf[i-1]==' ' || buf[i-1]=='\t')) buf[--i]=0;
    nargs=0;
    i=0;
    while(buf[i] && buf[i]!=' ' && buf[i]!='\t') {
      if(buf[i]>='a' && buf[i]<='z') buf[i]+='A'-'a';
      i++;
    }
    if(buf[i]) nargs=1;
    buf[i]=0;
    if(!strcmp(buf,"POST")) {
      if(nargs) goto badargs;
      printf("340 Send article; end with . on a line by itself\r\n");
      do_post();
      printf("441 End of article reached.\r\n");
    } else if(!strcmp(buf,"CAPABILITIES")) {
      if(nargs) goto badargs;
      printf("101 Capabilities:\r\nVERSION 2\r\nPOST\r\nIMPLEMENTATION Test posting capability\r\n.\r\n");
    } else if(!strcmp(buf,"QUIT")) {
      if(nargs) goto badargs;
      printf("205 Goodbye\r\n");
      return 0;
    } else {
      printf("500 Unknown command: %s\r\n",buf);
    }
    continue;
    badargs: printf("501 Bad arguments\r\n");
  }
  return 0;
}
